#define KEY	 0x0000DEAD   
#define CONFIG   "/etc/sitewho.conf"
#define GLGROUP  "/etc/group"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>


struct ONLINE {
	char		tagline[64],
			username[24],
			status[256],
 			host[256],
 			currentdir[256];
	long		groupid;
	time_t		login_time;
	struct		timeval tstart;   
	unsigned long	bytes_xfer; 
	pid_t		procid;
};


struct GROUP {
	char		*name;
	gid_t		id;
};


int	groups = 0,
	GROUPS = 0;

static struct ONLINE	*user;
static struct GROUP	**group;

int			 shmid;
struct shmid_ds 	 ipcbuf;
struct stat		 filestat;

char			*header,
			*footer,
			*glpath,
			*mpaths,
			*husers;
int			 maxusers,
			 showall,
			 uploads,
			 downloads,
                         onlineusers    = 0;
double			 total_dn_speed = 0,
      			 total_up_speed = 0;

char *tstr;
char* strtrim(char *s) {
 tstr = s;
 while ( tstr[0] == ' ' ) tstr++;
 return tstr;
}

unsigned long filesize(char *filename) {
 char	*file;

 file = malloc(strlen(glpath) + strlen(filename) + 2);
 sprintf(file, "%s/%s", glpath, filename);
 stat(file, &filestat);
 free(file);
 if ( ! filestat.st_size ) return 1;
 return filestat.st_size;
}


char* get_g_name(int gid) {
 int n;
 for ( n = 0 ; n < groups ; n++ ) if ( group[n]->id == gid ) return group[n]->name;
 return "NoGroup";
}


int strplen(char *strin) {
 int n = 0;
 while ( isprint(strin[n]) ) n++;
 return n;
}


short matchpath(char *instr, char *path) {
 int cnt, pos, k;

 k = strlen(instr) + 1;
 for ( cnt = pos = 0 ; cnt < k ; cnt++ )
  if ( instr[cnt] == ' ' || instr[cnt] == '\0' ) {
   if ( ! strncmp(instr + cnt - pos, path, pos - 1) ) { return 1; }
   pos = 0;
  } else pos++;
 return 0;
}
 

short strcomp(char *instr, char *searchstr) {
 int cnt, pos, k, l;  

 k = strlen(searchstr);
 l = strlen(instr) + 1;
 for ( cnt = pos = 0 ; cnt < l ; cnt++ )
  if ( instr[cnt] == ' ' || instr[cnt] =='\0' ) {
   if ( k == pos && ! strncmp(instr + cnt - pos, searchstr, pos - 1) ) { return 1; }
   pos = 0;
 } else pos++;
 return 0; 
}


void showusers(int x, int mode, char *ucomp) {
 char	status[20],
        online[20],
        filename[20],
        bar[20];
 struct timeval tstop;
 double speed;
 int	hours,
        mask,
        noshow,
        maskchar,
    	minutes,
    	seconds,
        cnt,
	len,
	i;
 time_t now;

 now = time( NULL );
 gettimeofday(&tstop, (struct timezone *)0 );

 while ( x + 1 ) {
  if ( user[x].procid ) {
   maskchar = ' ';
   mask = noshow = 0;

   if ( strcomp(husers, user[x].username) ) {
    if ( showall ) maskchar = '*';
     else noshow++;
   }

   if ( matchpath(mpaths, user[x].currentdir) ) {
    if ( showall ) maskchar = '*';
     else mask++;
   }

   if ( ! noshow ) {

    if ( ((!strncasecmp (user[x].status, "STOR ", 5) || !strncasecmp (user[x].status, "APPE ", 5)) && user[x].bytes_xfer) && ! mask ) {
     len = strplen(user[x].status);
     if ( len < 20 ) strncpy(filename, user[x].status + 5, len - 5);
      else strncpy(filename, user[x].status + len - 15, 15);
     filename[len - 5] = filename[16] = '\0';

     strcpy(bar, "?->");
     speed = (user[x].bytes_xfer / 1024.0) / ((tstop.tv_sec*1.)+(tstop.tv_usec/1000000.) -
                                              (user[x].tstart.tv_sec*1.)+(user[x].tstart.tv_usec/1000000.));
     total_up_speed += speed;
     uploads++;
     sprintf(status, "Up: %7.1fKBs", speed);
    } else if ((!strncasecmp (user[x].status, "RETR ", 5) && user[x].bytes_xfer) && ! mask ) {
     len = strplen(user[x].status);
     if ( len < 20 ) strncpy(filename, user[x].status + 5, len - 5);
      else strncpy(filename, user[x].status + len - 15, 15);
     filename[len - 5] = filename[15] = '\0';

     bar[ i = 15 * (user[x].bytes_xfer * 1. / filesize(user[x].currentdir)) ] = '\0';
     for ( cnt = 0 ; cnt < i ; cnt++ ) bar[cnt] = 'x';
     speed = (user[x].bytes_xfer / 1024.0) / ((tstop.tv_sec*1.)+(tstop.tv_usec/1000000.) -
                                              (user[x].tstart.tv_sec*1.)+(user[x].tstart.tv_usec/1000000.));
     total_dn_speed += speed;
     downloads++;
     sprintf(status, "Dn: %7.1fKBs", speed);
    } else {
     bar[0] = filename[0] = '\0'; hours = minutes = 0;
     seconds = now - user[x].tstart.tv_sec;
     while ( seconds >= 3600 ) { hours++;   seconds -= 3600; }
     while ( seconds >= 60 )   { minutes++; seconds -= 60; } 
     sprintf(status, "Idle: %02d:%02d:%02d", hours, minutes, seconds);
    }

    hours = minutes = 0;
    seconds = now - user[x].login_time;
    while ( seconds >= 3600 ) { hours++; seconds -= 3600; }
    while ( seconds >= 60 ) { minutes++; seconds -= 60; } 
    sprintf(online, "%02d:%02d:%02d", hours, minutes, seconds);

    if ( ! mode ) {
     printf("|%1c%-16.16s/%-10.10s | %-15s | %%   : %-15s |\n", maskchar, user[x].username, get_g_name(user[x].groupid), status, bar);
     printf("| %-27.27s | since %8s  | file: %-15s |\n", user[x].tagline, online, filename);
     printf("+-----------------------------------------------------------------------+\n");
     onlineusers++;
    } else if ( ! strcasecmp(ucomp, user[x].username) ){
     if ( ! onlineusers ) printf("\002%s\002 - %s", user[x].username, status);
      else printf(" - %s", status);
     onlineusers++;
    }
   }
  }
  x--;
 }
}



/* COMPARE USERFLAGS ON CHECKFLAGS */
short compareflags(char *flags, char *checkflags) {
 int  len1 = 0,
      len2 = 0,
      cnt  = 0;
 char *userflags;

 if ( flags != NULL ) len1 = strlen( userflags = flags );
  else len1 = strlen( userflags = "1234ABCDEFGHI" );
 len2 = strlen(checkflags);

 while ( len1 ) {
  if ( userflags[len1] != ' ' ) {
   cnt = len2;
   while ( cnt > 0 ) {
    cnt--;
    if ( userflags[len1] == checkflags[cnt] ) return 1;
   }
  }  
  len1--;
 }
 return 0;
}



/* READ CONFIGURATION FILE */
void readconfig(char *arg) {
 char	*buf,
        *cfgfilename;
 FILE	*cfgfile;
 int	 len = 0,
         size = 10,
         space = 0;

 len = strlen(arg);
 while ( arg[len] != '/' && len ) len--;
 arg[len] = '\0';

 if ( len == 0 ) {
  strcpy(arg, "/bin");
  len = 4;
 }
 
 cfgfilename = malloc(len + 14);
 sprintf(cfgfilename, "%s/sitewho.conf", arg);

 cfgfile = fopen(cfgfilename, "r");
 if ( cfgfile == NULL ) {
  printf("Config file does not exist (%s)\n", cfgfilename);
  exit(0);
 }
 free(cfgfilename);
 buf = malloc(size); len = 0;

 while ( fread(&buf[len], 1, 1, cfgfile) > 0 ) switch( buf[len] ) {
  case '\n':
   buf[len] = '\0';
   if ( ! strncasecmp(buf, "headerfile =", 12) ) { header = malloc(len - 11); strcpy(header, strtrim(buf + 12)); }
    else if ( !strncasecmp(buf, "footerfile =", 12) ) { footer = malloc(len - 11); strcpy(footer, strtrim(buf + 12)); }
    else if ( !strncasecmp(buf, "maskeddirectories =", 19) ) { mpaths = malloc(len - 18); strcpy(mpaths, buf + 19); }
    else if ( !strncasecmp(buf, "hiddenusers =", 13) ) { husers = malloc(len - 12); strcpy(husers, buf + 13); }
    else if ( !strncasecmp(buf, "glrootpath =", 12) ) { glpath = malloc(len - 11); strcpy(glpath, strtrim(buf + 12)); }
    else if ( !strncasecmp(buf, "seeallflags =", 13) ) showall = compareflags(getenv("FLAGS"), buf + 13);
    else if ( !strncasecmp(buf, "maxusers =", 10) ) maxusers = atoi(buf + 10);
   len = space = 0;
  break;
  case ' ' :
   if ( ! space ) break;
   space = -1;
  default  :
   len++;
   space++;
   if ( len == size ) {
    size <<= 1;
    buf = realloc(buf, size);
   }
 }

 if ( filesize("") == 1 ) glpath[0] = '\0';
 free(buf);
 fclose(cfgfile);
}



/* PRINT FILE */
void show(char *filename) {
 FILE	*file;
 int	n = 0;
 char	buf[128];
 char	*fname;

 fname = malloc( strlen(glpath) + strlen(filename) + 2 );
 sprintf( fname, "%s/%s", glpath, filename );

 if ( (file = fopen(fname, "r")) != NULL ) {
  while ( (n = fread(buf, 1, 128, file)) > 0 ) printf("%.*s", n, buf);
  fclose(file);
 }
 free(fname);
}




/* SHOW TOTALS */
void showtotals() {
 printf("| Up: %3i / %7.1fkbs | Dn: %3i / %7.1fkbs | Total: %3i / %7.1fkbs |\n", uploads, total_up_speed, downloads, total_dn_speed, uploads + downloads, total_up_speed + total_dn_speed );
 printf("| Currently %2i of %2i users are online...                                |\n", onlineusers, maxusers);
}



/* Buffer groups file */
void buffer_groups(char *groupfile) {
 char	*f_buf,
	*g_name,
	*f_name;
 long	f, n, m,
	f_size,
	g_id,
	g_n_size,
	l_start = 0;

 f_name = malloc( strlen(glpath) + strlen(groupfile) + 2 );
 sprintf( f_name, "%s/%s", glpath, groupfile );

 f = open( f_name, O_NONBLOCK );
 fstat( f, &filestat );
 f_size = filestat.st_size;
 f_buf  = malloc( f_size );
 read( f, f_buf, f_size );

 for ( n = 0 ; n < f_size ; n++ ) if ( f_buf[n] == '\n' ) GROUPS++;
 group = malloc( GROUPS * sizeof( int ) );

 for ( n = 0 ; n < f_size ; n++ ) {
  if ( f_buf[n] == '\n' || n == f_size ) {
   f_buf[n] = 0;
   m        = l_start;
   while ( f_buf[m] != ':' && m < n ) m++;
   if ( m != l_start ) {
    f_buf[m] = 0;
    g_name   = f_buf + l_start;
    g_n_size = m - l_start;
    m        = n;
    while ( f_buf[m] != ':' && m > l_start ) m--;
    f_buf[m] = 0;
    while ( f_buf[m] != ':' && m > l_start ) m--;
    if ( m != n ) {
     g_id = atoi( f_buf + m + 1 );
     group[groups] = malloc( sizeof( struct GROUP ) );
     group[groups]->name = malloc( g_n_size + 1 );
     strcpy( group[groups]->name, g_name );
     group[groups]->id = g_id;
     groups++;
    }
   }
   l_start = n + 1;
  }
 }
 
 close( f );
 free( f_buf );
 free( f_name );
}





/* CORE CODE */
main ( int argc, char **argv ) {


  readconfig(argv[0]);
  buffer_groups(GLGROUP);

  if ((shmid = shmget((key_t)KEY, 0, 0)) == -1) {
   if ( argc == 1 ) { 
    show(header);
    showtotals();
    show(footer);
   } else {
    printf("\002%s\002 is not online\n", argv[1]);
   }
   exit(0);
  }
            
  if ((user = (struct ONLINE *)shmat( shmid, NULL, SHM_RDONLY)) == (struct ONLINE *)-1) {
   printf("Error!: (SHMAT) failed...");
   exit(1);
  }
      
  shmctl( shmid, IPC_STAT, &ipcbuf);

  if ( argc == 1 ) show(header);
  showusers(ipcbuf.shm_segsz / sizeof( struct ONLINE ) - 1, argc - 1, argv[1]);
  if ( argc == 1 ) {
   showtotals();
   show(footer);
  } else {
   if ( ! onlineusers ) printf("\002%s\002 is not online\n", argv[1]);
    else printf("\n"); 
  }
 exit(0);
}
